<script src="lib/utils.js"></script>

<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../app-layout/app-toolbar/app-toolbar.html">
<link rel="import" href="../paper-dropdown-menu/paper-dropdown-menu.html">
<link rel="import" href="../paper-listbox/paper-listbox.html">
<link rel="import" href="../paper-item/paper-item.html">
<link rel="import" href="../paper-input/paper-input.html">
<link rel="import" href="../iron-icons/iron-icons.html">
<link rel="import" href="../paper-icon-button/paper-icon-button.html">

<dom-module id="dez-label-editor">
  <template>
    <style>
    app-toolbar {
        background-color: #EFF5FB;
        height: 164px;
    }


    .toolbar-column {
        display: flex;
        flex-direction: column;
    }

    .toolbar-row {
        width: 20em;
        height: 82px;
        display: flex;
        flex-direction: row;
    }

    paper-input, paper-dropdown-menu, paper-textarea {
    {
        margin-right: 60px;
    }

    paper-input, paper-dropdown-menu
    {
        --paper-input-container-input: { font-size: 20px; };
        --paper-input-container-label: { font-size: 20px; };
    }

    @media (max-width: 1024px) {
      .hidden-xs {
        display: none;
      }
    }

    @media (max-width: 1280px) {
      .hidden-md {
        display: none;
      }
    }

    </style>

    <app-toolbar>

        <template is="dom-if" if=[[visible]]>

            <div main-title></div>

            <div class='toolbar-column'>
            <div class='toolbar-row'>

            <div>
                <paper-icon-button icon="arrow-back" title="Previous label of this type" on-tap="_prevLabelOfType"></paper-icon-button>
                <paper-icon-button icon="arrow-forward" title="Next label of this type" on-tap="_nextLabelOfType"></paper-icon-button>
            </div>
            <paper-dropdown-menu label="Type" noink no-animations vertical-align="bottom">
                <paper-listbox slot="dropdown-content" attr-for-selected="item-name" selected="[[_label.type]]" on-selected-changed="_changeType" style="width:12em">
                    <template is="dom-repeat" items="[[_labelTypes.typesNameColor]]">
                        <paper-item item-name="[[item.name]]" style="background-color:rgba([[item.rgb]],0.2); margin:4px; min-height:30px;[[item.style]]">[[item.name]]</paper-item>
                    </template>
                </paper-listbox>
            </paper-dropdown-menu>

            <paper-input label="Tag" value="[[_label.tag]]" on-value-changed="_changeTag" style="width:5em"></paper-input>

            </div>
            <div class='toolbar-row'>

            <paper-input
                class="hidden-xs"
                label="Start"
                value="[[_start]]"
                on-value-changed="_changeStart"
                on-focused-changed="_restoreStart"
                auto-validate
                pattern="[[_fracNotationPattern]]"
                style="width:5.5em">
            </paper-input>
            <paper-input
                class="hidden-xs"
                label="[[_durationLabel]]"
                value="[[_duration]]"
                on-value-changed="_changeDuration"
                on-focused-changed="_restoreDuration"
                auto-validate
                pattern="[[_fracNotationPattern]]"
                style="width:5.5em">
            </paper-input>
            <paper-input
                class="hidden-xs"
                label="End"
                value="{{_end}}"
                on-value-changed="_changeEnd"
                on-focused-changed="_restoreEnd"
                auto-validate
                pattern="[[_fracNotationPattern]]"
                style="width:5.5em">
            </paper-input>
            </div>
            </div>

            <paper-textarea
                class="hidden-xs"
                label="Comment"
                rows="4" max-rows="4"
                value="[[_label.comment]]"
                on-value-changed="_changeComment"
                style="width:30em;">
            </paper-textarea>

            <paper-icon-button icon="delete" title="Delete this label" on-tap="_deleteSelectedLabel"></paper-icon-button>

        </template>

    </app-toolbar>

  </template>

  <script>
    /**
     * `dez-label-editor`
     *
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class DezLabelEditor extends Polymer.MutableData(Polymer.Element) {
      static get is() { return 'dez-label-editor'; }
      static get properties() {
        return {
            visible: {
                type: Boolean,
                value: false
            },
            _label: Object,
            _timeSignature : {
                type: String,
                value: {
                    numerator: 4,
                    denominator: 4,
                    upbeat: 0
                }
            }
        };
      }

      constructor () {
        super()
        this._durationLabel = "Duration (IOI)"
      }

      _updateLabel (label) {
        this._label = label
        this._start = this._toMeasureFrac(this._label.start)
        this._duration = this._label.genericDuration == 0 ? "" : this._toDurationMeasureFrac(this._label.genericDuration)
        this._end = this._label.genericDuration == 0 ? "" : this._toMeasureFrac(this._label.end);
        this._durationLabel = "Duration" + (this._label.ioiMode?" (IOI)":"")
      }

      set analysis (analysis) {
        this._analysis = analysis
        this._labelTypes = this._analysis.labelTypes
        this._analysis.addEventListener('label-selected', event => {
          this._updateLabel(event.detail.label)
          this.visible = true;
        })
        this._analysis.addEventListener('label-set', event => {
          if (this._label && this._label.id == event.detail.label.id) {
            this._updateLabel(event.detail.label)
          }
        })
        this._analysis.addEventListener('label-removed', event => {
          this.visible = false
        })
        this._analysis.addEventListener('analysis-erased', event => {
          this.visible = false
        })
      }

      ready () {
          super.ready()
          let reString = reMeasureFrac.toString()
          this._fracNotationPattern = reString.substring(1,reString.length-1);
      }

      set timeSignature (timeSignature) {
          this._timeSignature = timeSignature;
      }

      _changeType (event, detail) {
          this._label.type = detail.value;
          this._analysis.setLabel(this._label)
      }

      _changeTag (event, detail) {
          this._label.tag = detail.value;
          this._analysis.setLabel(this._label)
      }

      _changeComment (event, detail) {
          this._label.comment = detail.value;
          this._analysis.setLabel(this._label)
      }

      _changeStart (event, detail) {
          if (event.target.validate() && this._start != detail.value && detail.value != "") {
              this._label.start = this._parseMeasureFrac(detail.value);
              this._end = this._label.genericDuration == 0 ? "" : this._toMeasureFrac(this._label.end);
              this._analysis.setLabel(this._label)
          }
      }

      _restoreStart (event, detail) {
          if (detail.value == false) {
              this._start = this._toMeasureFrac(this._label.start)
              event.target.value = this._start; // why explicitly change value?
          }
      }

      _changeDuration (event, detail) {
          if (event.target.validate() && this._duration != detail.value) {
              if (detail.value == "" || detail.value == "0") {
                  this._label.genericDuration = 0;
                  this._end = ""
              } else {
                  this._label.genericDuration = this._parseDurationMeasureFrac(detail.value)
                  this._end = this._toMeasureFrac(this._label.end);
              }
              this._analysis.setLabel(this._label)
          }
      }

      _restoreDuration (event, detail) {
          if (detail.value == false) {
              this._duration = this._label.genericDuration == 0 ? "" : this._toDurationMeasureFrac(this._label.genericDuration)
              event.target.value = this._duration; // why explicitly change value?
          }
      }

      _changeEnd (event, detail) {
          if (event.target.validate() && this._end != detail.value) {
              if (detail.value == "") {
                  this._label.end = this._label.start
                  this._duration = ""
              } else {
                  this._label.end = this._parseMeasureFrac(detail.value);
                  this._duration = this._toDurationMeasureFrac(this._label.genericDuration);
              }
              this._analysis.setLabel(this._label)
          }
      }

      _restoreEnd (event, detail) {
          if (detail.value == false) {
              this._end = this._label.genericDuration == 0 ? "" : this._toMeasureFrac(this._label.end)
              event.target.value = this._end; // why explicitly change value?
          }
      }

      _deleteSelectedLabel () {
        this._analysis.removeLabel(this._label.id)
      }

      _prevLabelOfType () {
          this.dispatchEvent(new CustomEvent('prev-type-button-pressed'));
      }
      _nextLabelOfType () {
          this.dispatchEvent(new CustomEvent('next-type-button-pressed'));
      }

      _toMeasureFrac (value) {
          return toMeasureFrac(
              value,
              this._timeSignature.numerator,
              this._timeSignature.denominator,
              this._timeSignature.upbeat
          );
      }

      _toDurationMeasureFrac (value) {
          return toDurationMeasureFrac(
              value,
              this._timeSignature.numerator,
              this._timeSignature.denominator
          );
      }

      _parseMeasureFrac (value) {
          return parseMeasureFrac(
              value,
              this._timeSignature.numerator,
              this._timeSignature.denominator,
              this._timeSignature.upbeat
          )
      }

      _parseDurationMeasureFrac (value) {
          return parseDurationMeasureFrac(
              value,
              this._timeSignature.numerator,
              this._timeSignature.denominator
          )
      }

    }

    window.customElements.define(DezLabelEditor.is, DezLabelEditor);
  </script>
</dom-module>
